package com.loafle.overflow.meta;

import javax.persistence.*;
import java.sql.Timestamp;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "TBL_META_PROBE_PACKAGE", schema = "public", catalog = "postgres")
public class MetaProbePackage {
    private long id;
    private MetaProbeVersion versionId;
    private MetaProbeOs osId;
    private MetaProbeArchitecture architectureId;
    private Date createDate;

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    @ManyToOne
    @JoinColumn(name = "VERSION_ID", nullable = false)
    public MetaProbeVersion getVersionId() {
        return versionId;
    }

    public void setVersionId(MetaProbeVersion versionId) {
        this.versionId = versionId;
    }

    @ManyToOne
    @JoinColumn(name = "OS_ID", nullable = false)
    public MetaProbeOs getOsId() {
        return osId;
    }

    public void setOsId(MetaProbeOs osId) {
        this.osId = osId;
    }

    @ManyToOne
    @JoinColumn(name = "ARCHITECTURE_ID", nullable = false)
    public MetaProbeArchitecture getArchitectureId() {
        return architectureId;
    }

    public void setArchitectureId(MetaProbeArchitecture architectureId) {
        this.architectureId = architectureId;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "CREATE_DATE", nullable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

//    @Override
//    public boolean equals(Object o) {
//        if (this == o) return true;
//        if (o == null || getClass() != o.getClass()) return false;
//
//        MetaProbePackage that = (MetaProbePackage) o;
//
//        if (id != that.id) return false;
//        if (versionId != that.versionId) return false;
//        if (osId != that.osId) return false;
//        if (architectureId != that.architectureId) return false;
//        if (createDate != null ? !createDate.equals(that.createDate) : that.createDate != null) return false;
//
//        return true;
//    }

//    @Override
//    public int hashCode() {
//        int result = (int) (id ^ (id >>> 32));
//        result = 31 * result + (int) versionId;
//        result = 31 * result + (int) osId;
//        result = 31 * result + (int) architectureId;
//        result = 31 * result + (createDate != null ? createDate.hashCode() : 0);
//        return result;
//    }
}
